{
Copyright (C) 2000-2002 XP38 Team, www.Back2D.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}




unit Unit1;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DXSprite, DXClass, DXDraws, StdCtrls, DXInput, DXSounds, Menus, dib,
  MPlayer, DXPlay, DirectX, inifiles, ComCtrls;

type
  TGameScene = (gsNone, gsTitle, gsmain, gsGameOver, gsMenu);

type
  TForm1 = class(TdxForm)
    DXTimer1: TDXTimer;
    DXSpriteEngine: TDXSpriteEngine;
    DXInput: TDXInput;
    MediaPlayer1: TMediaPlayer;
    Draw: TDXDraw;
    ImageList: TDXImageList;
    DXSound: TDXSound;
    DXWaveList: TDXWaveList;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure DXTimer1Timer(Sender: TObject; LagCount: Integer);
    procedure DrawInitializing(Sender: TObject);
    procedure DrawInitialize(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
    FScene: TGameScene;
    FNextScene: TGameScene;
    FScenePrevious: TGameScene;
    FBlink: DWORD;
    FBlinkTime: DWORD;
    procedure blinkstart;
    procedure blinkupdate;
    procedure StartScene(Scene: TGameScene);
    procedure StartSceneTitle;
    procedure StartScenemain;
    procedure StartSceneGameOver;
    procedure StartSceneMenu;
    procedure EndScene;
    procedure EndSceneTitle;
    procedure EndSceneMain;
    procedure EndSceneGameOver;
    procedure EndSceneMenu;
    procedure SceneTitle;
    procedure SceneMain;
    procedure SceneGameOver;
    procedure SceneMenu;
    procedure levelinit;
    procedure vollbild;
    procedure newgame;
    procedure escape_pressed;
    procedure enter_pressed;
  public
    { Public-Deklarationen }
  end;

const
  xspeed = 18;
  gravbasis = 20; //(mu integer sein!) der Parameter bestimmt, wie stark die Grav ist.
var
  Form1: TForm1;
  usermap: string;
  number_of_players, local_player_index: byte;
  fullscreen_enabled, erstemal_dieses_level, erstemal_dieses_game, beide_killed: boolean;
  level: word (*=3*);
  stone_left: integer;
implementation
type
  txp38sprite = class(Timagesprite)
  public {Eigenschaften und funktionen, die alle Sprites haben sollen}
    beule: boolean; //hat sich den opf gestoen und springt erst dann wieder, wenn er gelandet ist.
    ximp, yimp: integer;
    coll, gesprungen: boolean;
  protected
    procedure movement;
  end;

type
  TPlayerSprite = class(txp38Sprite)
  public
    player_nr: byte;
    umkehr: boolean;
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure DoCollision(Sprite: TSprite; var Done: Boolean); override;
  end;

  TStachelSprite = class(txp38Sprite)
  end;
  TRoboSprite = class(txp38Sprite)
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure DoCollision(Sprite: TSprite; var Done: Boolean); override;
  end;

  tfreiRobosprite = class(txp38Sprite)
  public
    nachoben, nachunten: real;
    ja: boolean;
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure DoCollision(Sprite: TSprite; var Done: Boolean); override;
  end;

  Tflugrobosprite = class(txp38Sprite)
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure DoCollision(Sprite: TSprite; var Done: Boolean); override;
  end;

  trobokannonesprite = class(txp38Sprite) //die Kannone
  public
    startpunkt: tpoint;
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure DoCollision(Sprite: TSprite; var Done: Boolean); override;
  end;

  trobolinksrechtssprite = class(txp38Sprite) //wandert von links nach rechts
  public
    start, ende: tpoint; //start und endpunkt
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure DoCollision(Sprite: TSprite; var Done: Boolean); override;
  end;

  trobolinksrechtssprite2 = class(txp38Sprite) //wandert von links nach rechts
  public
    start, ende: tpoint; //start und endpunkt
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure DoCollision(Sprite: TSprite; var Done: Boolean); override;
  end;



  tumkehrsteinsprite = class(Timagesprite)
  end;
  TherzSprite = class(TimageSprite)
  end;
  TPlattformSprite = class(TimageSprite)
  end;
  TBGSprite = class(TimageSprite)
  end;
  TRubinSprite1 = class(TimageSprite)
  end;
  TRubinSprite2 = class(TimageSprite)
  end;
  TRubinSprite3 = class(TimageSprite)
  end;
  tumkehrstein = record
    sprite: tumkehrsteinsprite;
    x: integer;
    y: integer;
    zeit: dword;
  end;
  therz = record
    sprite: therzsprite;
    x: integer;
    y: integer;
  end;
  trubin1 = record
    sprite: trubinsprite1;
    x: integer;
    y: integer;
  end;
  trubin2 = record
    sprite: trubinsprite2;
    x: integer;
    y: integer;
  end;
  trubin3 = record
    sprite: trubinsprite3;
    x: integer;
    y: integer;
  end;

  tPlayer = record
    sprite: Tplayersprite;
    name: string[35];
    leben: shortint;
    punkte: integer;
    health: word;
    spielzeit: integer;
    killed: boolean; //wurde gekillt
    leben_weggenommen: boolean;
    unbesiegbar: integer (*=3000*); (*in millisec, anfangs nicht zu zerstren*)
  end;
//HighScoreTable
  list_entry = record
    Name: string[30];
    minuten, sekunden: byte;
    punkte: Integer;
  end;
  ttable = array[1..10] of list_entry;
//Men
  tmenuitems = record
    name: string[50];
    next_menu: Byte;
  end;
  tMenu = record
    name: string[50];
    item: array[1..12] of tmenuitems;
    prev_menu: byte;
    number_of_items: byte;
  end;
  ttext = record
    line: array[1..70] of string[255];
  end;


var herz: array[1..100] of therz;
  rubin1: array[1..100] of trubin1;
  rubin2: array[1..100] of trubin2;
  rubin3: array[1..100] of trubin3;
  configu: tinifile;
  currentmidifile: string;
  textart: byte;
  Player: array[1..2] of TPlayer;
  gameoverscenestartzeit: integer;
  atext: array[0..1] of ttext;
  umkehrstein: tumkehrstein;
  firsttickcount, startzeit, xschritt, currentfps, lastfps, grav: integer;
  HighScoreTable: ttable;
  impuls, scrollbetrag: real;
  dont_move, midilooped, eigenemaps, dovollbild: boolean;
  player_selected, currentselecteditem, currentmenu, gameoverSceneMessageNr: byte;
  maxheight: double;
  Amenu: array[0..10] of tmenu;
  ausermaps: Tstringlist;
  currentusermapindex: integer;
  lastkey: char;
  bgindex, number_of_thiskey: byte;
 {end of TYPE}

{$R *.DFM}



procedure PlaySound(const Name: string; Wait: Boolean);
begin
  if form1.dxsound.Initialized then
  begin
    form1.dxwavelist.Items.Find(Name).Play(Wait);
  end;
end;

procedure Playmidi(const Name: string; looped: Boolean);
begin
  currentmidifile := extractfilepath(paramstr(0)) + name + '.mid';
  if amenu[2].item[1].name = 'Music: ON' then
  try
    form1.mediaplayer1.notify := false;
    form1.mediaplayer1.fileName := currentmidifile;
    form1.mediaplayer1.Open;
    form1.mediaplayer1.Stop;
    midilooped := looped;
    form1.mediaplayer1.play;
  except
    MessageDlg('Mediaplayer doesnt work!', mtWarning, [mbOK], 0);
  end;
end;





procedure tform1.levelinit;
type TItems = (nichts, therz, tplayer, trobo, tlokalbot, tlokalbot2, tplattform,
    tplattform2, tgrasmauerende_r, tgrasmauerende_l, tdreck1, tdreck2, tdreck3, tdreck4, tdreck5, tdreck6,
    tdreck7, tdreck8, tdreck9, tgras1, tgras2, tgras3, tgras4, tgras5, tkrone, tkrone2,
    tbaum1, tbaum11, tbaum2, tbaum3, tbaum4, tbaum5, tbaum6, tbaum7, tbaum8, tbaum9, tbaum12, tbaum13, tbaum14,
    trubin1, trubin2, trubin3, tumkehrstein, tkanone, tplattform6, tplattform7, tplattform8, tplattform9,
    tgegner1, tgegner2, tgegner3, tgegner5);
type tmapItem = record
    x, y: Integer;
    Art: titems;
  end;
  tmap = record
    items: array[1..500] of tmapItem;
    number_of_items: word;
  end;
var temp_map: tmap;
  playingusermap: boolean;
  procedure PlattformSpriteErstellen(bild: string; mapIndex: Integer);
  begin
    with TPlattformSprite.create(form1.DXSpriteEngine.Engine) do
    begin
      Image := form1.Imagelist.Items.Find(bild);
      x := temp_map.items[mapIndex].x;
      y := temp_map.items[mapIndex].y;
      z := 1;
      Width := image.Width;
      height := image.Height;
    end;
  end;

  //  begin
//    with TRubinSprite.create(form1.DXSpriteEngine.Engine) do
//    begin
//      Image := form1.Imagelist.Items.Find(bild);
//      x := temp_map.items[mapindex].x;
//      y := temp_map.items[mapindex].y;
//      z := 2;
//      Width := image.Width;
//      height := image.Height;
//    end;
//
//  end;

var i: word;
  dateiname, txt: string;
  datei: file of tmap;
  xw, yw: Integer;
  herz_zaehler, rubin1_zaehler, rubin2_zaehler, rubin3_zaehler: word;
begin
  if erstemal_dieses_game then
  begin
    playmidi('bg', true);
    for i := 1 to number_of_players do
    begin
      player[i].leben := 1 + 1 + 1+1+1;
      player[i].punkte := 0;
      player[i].health := 0;                                                                
      player[i].spielzeit := 0;
    end;
    level := 1;
    erstemal_dieses_level := true;
  end;
  playingusermap := false;
  if (paramstr(1) <> '') and (paramstr(1) <> '-debug') then
  begin
    dateiname := paramstr(1);
    playingusermap := true;
  end;
  if usermap <> '' then
  begin
    dateiname := usermap;
    playingusermap := true;
  end;
  if eigenemaps then
  begin
    dateiname := 'map' + inttostr(level) + '.map';
    playingusermap := true;
  end;
  if playingusermap then
  begin
    if (extractfileext(dateiname) = '') and not fileexists(dateiname) then
      dateiname := dateiname + '.map'; //.map anhngen
    if fileexists(dateiname) then
    try
      assignfile(datei, dateiname);
      Reset(datei);
      read(datei, temp_map)
    except
      startscene(gstitle);
      exit;
    end
    else {if file doesn't exist}
    begin
      gameoverSceneMessageNr := 1;
      startscene(gsgameover);
      exit;
    end;
  end {of usermap}
  else {if not playing usermap}
  begin
    dateiname := 'map' + inttostr(level);
    try
      with TResourceStream.Create(HInstance, dateiname, RT_RCDATA) do
      try
        ReadBuffer(temp_map, SizeOf(temp_map));
      finally
        Free;
      end;
    except
      gameoverSceneMessageNr := 2;
      if player[1].spielzeit = 0 then player[1].spielzeit := (gettickcount - startzeit) div 1000; //sekunden
      if player[2].spielzeit = 0 then player[2].spielzeit := (gettickcount - startzeit) div 1000; //sekunden
      startscene(gsgameover); {was machen, wenn er die ressource nicht findet??}
      exit;
    end;
  end;


  dxSpriteEngine.Engine.Clear;
  if erstemal_dieses_level then //Entering Level
  begin
    bgindex := random(10);
    beide_killed := false;
    draw.surface.fill(0);
    with Draw.Surface.Canvas do
    begin
      Brush.Style := bsClear;
      Font.Color := clred;
      Font.Size := 30;
      Font.Name := 'Arial';
      if playingusermap then
        txt := 'Entering Usermap'
      else
        txt := 'Entering Level ' + inttostr(level);
      Textout(250, 10, txt);
      Release;
    end;
    dxspriteengine.draw;
    draw.flip;
    sleep(1000);
  end;
  herz_zaehler := 0;
  rubin1_zaehler := 0;
  rubin2_zaehler := 0;
  rubin3_zaehler := 0;
  stone_left := 0;
  i := 0;
  while i <= temp_map.number_of_items do
  begin
    inc(i);
    case temp_map.items[i].art of
      therz:
        begin
           //herz create
          inc(herz_zaehler);
          xw := temp_map.items[i].x;
          yw := temp_map.items[i].y;
          if (not (herz[herz_zaehler].sprite = nil)) or erstemal_dieses_level then
          begin
            herz[herz_zaehler].sprite := TherzSprite.Create(DXSpriteEngine.Engine);
            if erstemal_dieses_level then
            begin
              herz[herz_zaehler].x := xw;
              herz[herz_zaehler].y := yw;
            end
            else
            begin
              xw := herz[herz_zaehler].x;
              yw := herz[herz_zaehler].y;
            end;
            with TherzSprite(herz[herz_zaehler].sprite) do
            begin
              inc(stone_left);
              Image := Imagelist.Items.Find('herz');
              x := xw;
              y := yw;
              z := 2;
              Width := image.Width;
              height := image.Height;
            end;
          end;

        end; //so nur mit plattformen!!!
      tplattform: PlattformSpriteErstellen('baum10', i);
      tgrasmauerende_r: PlattformSpriteErstellen('grasmauerende_r', i);
      tgrasmauerende_l: PlattformSpriteErstellen('grasmauerende_l', i);
      tdreck1: PlattformSpriteErstellen('dreck1', i);
      tdreck2: PlattformSpriteErstellen('dreck2', i);
      tdreck3: PlattformSpriteErstellen('dreck3', i);
      tdreck4: PlattformSpriteErstellen('dreck4', i);
      tdreck5: PlattformSpriteErstellen('dreck5', i);
      tdreck6: PlattformSpriteErstellen('dreck6', i);
      tdreck7: PlattformSpriteErstellen('dreck7', i);
      tdreck8: PlattformSpriteErstellen('dreck8', i);
      tdreck9: PlattformSpriteErstellen('dreck9', i);
      tplattform2: PlattformSpriteErstellen('grasmauer', i);
      tgras1: PlattformSpriteErstellen('gras1', i);
      tgras2: PlattformSpriteErstellen('gras2', i);
      tgras3: PlattformSpriteErstellen('gras3', i);
      tgras4: PlattformSpriteErstellen('gras4', i);
      tgras5: PlattformSpriteErstellen('gras5', i);
      tplattform6: PlattformSpriteErstellen('plattform6', i);
      tplattform7: PlattformSpriteErstellen('plattform7', i);
      tplattform8: PlattformSpriteErstellen('plattform8', i);
      tplattform9: PlattformSpriteErstellen('plattform9', i);
      tkrone2: PlattformSpriteErstellen('krone2', i);
      tkrone:
        with TbgSprite.create(form1.DXSpriteEngine.Engine) do
        begin
          Image := Imagelist.Items.Find('krone');
          x := temp_map.items[i].x;
          y := temp_map.items[i].y;
          z := 1;
          Width := image.Width;
          height := image.Height;
        end;
      tbaum1: PlattformSpriteErstellen('baum1', i);
      tbaum2: PlattformSpriteErstellen('baum2', i);
      tbaum3: PlattformSpriteErstellen('baum3', i);
      tbaum4: PlattformSpriteErstellen('baum4', i);
      tbaum5: PlattformSpriteErstellen('baum5', i);
      tbaum6: PlattformSpriteErstellen('baum6', i);
      tbaum7: PlattformSpriteErstellen('baum7', i);
      tbaum8: PlattformSpriteErstellen('baum8', i);
      tbaum9: PlattformSpriteErstellen('baum9', i);
      tbaum11: PlattformSpriteErstellen('baum11', i);

      tbaum12:
        begin
          with TBGSprite.create(form1.DXSpriteEngine.Engine) do
          begin
            Image := form1.Imagelist.Items.Find('baum12');
            x := temp_map.items[i].x;
            y := temp_map.items[i].y;
            z := 1;
            Width := image.Width;
            height := image.Height;
          end;
        end;
      tbaum13:
        begin
          with TBGSprite.create(form1.DXSpriteEngine.Engine) do
          begin
            Image := form1.Imagelist.Items.Find('baum13');
            x := temp_map.items[i].x;
            y := temp_map.items[i].y;
            z := 1;
            Width := image.Width;
            height := image.Height;
          end;
        end;
      tbaum14:
        begin
          with TBGSprite.create(form1.DXSpriteEngine.Engine) do
          begin
            Image := form1.Imagelist.Items.Find('baum14');
            x := temp_map.items[i].x;
            y := temp_map.items[i].y;
            z := 1;
            Width := image.Width;
            height := image.Height;
          end;
        end;
      trubin1:
        begin
           //rubin1 create
          inc(rubin1_zaehler);
          xw := temp_map.items[i].x;
          yw := temp_map.items[i].y;
          if (not (rubin1[rubin1_zaehler].sprite = nil)) or erstemal_dieses_level then
          begin
            rubin1[rubin1_zaehler].sprite := TrubinSprite1.Create(DXSpriteEngine.Engine);
            if erstemal_dieses_level then
            begin
              rubin1[rubin1_zaehler].x := xw;
              rubin1[rubin1_zaehler].y := yw;
            end
            else
            begin
              xw := rubin1[rubin1_zaehler].x;
              yw := rubin1[rubin1_zaehler].y;
            end;
            with TrubinSprite1(rubin1[rubin1_zaehler].sprite) do
            begin
              Image := Imagelist.Items.Find('rubin1');
              x := xw;
              y := yw;
              z := 2;
              Width := image.Width;
              height := image.Height;
            end;
          end;
        end;
      trubin2:
        begin
           //rubin1 create
          inc(rubin2_zaehler);
          xw := temp_map.items[i].x;
          yw := temp_map.items[i].y;
          if (not (rubin2[rubin2_zaehler].sprite = nil)) or erstemal_dieses_level then
          begin
            rubin2[rubin2_zaehler].sprite := TrubinSprite2.Create(DXSpriteEngine.Engine);
            if erstemal_dieses_level then
            begin
              rubin2[rubin2_zaehler].x := xw;
              rubin2[rubin2_zaehler].y := yw;
            end
            else
            begin
              xw := rubin2[rubin2_zaehler].x;
              yw := rubin2[rubin2_zaehler].y;
            end;
            with TrubinSprite2(rubin2[rubin2_zaehler].sprite) do
            begin
              Image := Imagelist.Items.Find('rubin2');
              x := xw;
              y := yw;
              z := 2;
              Width := image.Width;
              height := image.Height;
            end;
          end;
        end;

      trubin3: begin
           //rubin3 create
          inc(rubin3_zaehler);
          xw := temp_map.items[i].x;
          yw := temp_map.items[i].y;
          if (not (rubin3[rubin3_zaehler].sprite = nil)) or erstemal_dieses_level then
          begin
            rubin3[rubin3_zaehler].sprite := TrubinSprite3.Create(DXSpriteEngine.Engine);
            if erstemal_dieses_level then
            begin
              rubin3[rubin3_zaehler].x := xw;
              rubin3[rubin3_zaehler].y := yw;
            end
            else
            begin
              xw := rubin3[rubin3_zaehler].x;
              yw := rubin3[rubin3_zaehler].y;
            end;
            with TrubinSprite3(rubin3[rubin3_zaehler].sprite) do
            begin
              Image := Imagelist.Items.Find('rubin3');
              x := xw;
              y := yw;
              z := 2;
              Width := image.Width;
              height := image.Height;
            end;
          end;
        end;

      tkanone:
        begin
//          form1.dxwavelist.items.find('kanone').pan := Integer(20000 * (temp_map.items[i].x + 11) div 800) - 10000;
          PlaySound('kanone', False);
          with Trobokannonesprite.create(DXSpriteEngine.Engine) do //ist die Kannonenkugel
          begin
            Image := Imagelist.Items.Find('bullet');
            x := temp_map.items[i].x + 11;
            y := temp_map.items[i].y - 30;
            startpunkt.x := temp_map.items[i].x + 11;
            startpunkt.y := temp_map.items[i].y - 30;
            z := 2;
            Width := image.Width;
            height := image.Height;
          end;
          PlattformSpriteErstellen('kanone', i); //hier wird die kanone erstellt
        end;
      tumkehrstein:
        begin
          if not (umkehrstein.sprite = nil) or erstemal_dieses_level then
          begin
            umkehrstein.sprite := tumkehrsteinsprite.create(form1.DXSpriteEngine.engine);
            with tumkehrsteinsprite(umkehrstein.sprite) do
            begin
              Image := Imagelist.Items.Find('rubin4');
              x := temp_map.items[i].x;
              y := temp_map.items[i].y;
              z := 2;
              width := image.width;
              height := image.height;
            end;
          end;
        end;

      tgegner5:
        begin
          with TstachelSprite.create(form1.DXSpriteEngine.Engine) do
          begin
            Image := form1.Imagelist.Items.Find('stachel');
            x := temp_map.items[i].x;
            y := temp_map.items[i].y;
            z := 1;
            Width := image.Width - 5;
            height := image.Height - 5;
          end;
        end;

      trobo:
        begin
          with TroboSprite.create(form1.DXSpriteEngine.Engine) do
          begin
            Image := form1.Imagelist.Items.Find('drache_l');
            x := temp_map.items[i].x;
            y := temp_map.items[i].y;
            z := 2;
            Width := image.Width;
            height := image.Height;
          end;
        end;

      tlokalbot:
        with trobolinksrechtssprite.create(form1.DXSpriteEngine.Engine) do
        begin
          Image := form1.Imagelist.Items.Find('wurm_l');
          start.x := temp_map.items[i].x;
          start.y := temp_map.items[i].y;
          x := start.x;
          y := start.y;
          inc(i); //gehe zum nchsten eintrag
          ende.x := temp_map.items[i].x;
          ende.y := temp_map.items[i].y;
          z := 2;
          Width := image.Width;
          height := image.Height;
        end;
      tlokalbot2:
        with trobolinksrechtssprite2.create(form1.DXSpriteEngine.Engine) do
        begin
          Image := form1.Imagelist.Items.Find('kaefer_l');
          start.x := temp_map.items[i].x;
          start.y := temp_map.items[i].y;
          x := start.x;
          y := start.y;
          inc(i); //gehe zum nchsten eintrag
          ende.x := temp_map.items[i].x;
          ende.y := temp_map.items[i].y;
          z := 2;
          Width := image.Width;
          height := image.Height;
        end;


{  //frei- und flugrobo create}
      tgegner1:
        with tflugroboSprite.create(form1.DXSpriteEngine.Engine) do //der freie Vogel
        begin //im orginal wurde hier form1 weggelassen //letzt
          Image := form1.Imagelist.Items.Find('gegner1_l');
          x := temp_map.items[i].x;
          y := temp_map.items[i].y;
          z := 2;
          Width := image.Width;
          height := image.Height;
        end;

      tgegner2:
        with Tfreirobosprite.create(DXSpriteEngine.Engine) do //der Falke
        begin
          Image := Imagelist.Items.Find('gegner2_l');
          x := temp_map.items[i].x;
          y := temp_map.items[i].y;
          z := 2;
          ja := false;
          nachunten := 0;
          nachoben := 0;
          Width := image.Width;
          height := image.Height;
        end;
      tgegner3:
        with tstachelSprite.create(form1.DXSpriteEngine.Engine) do
        begin
          Image := form1.Imagelist.Items.Find('gegner5');
          x := temp_map.items[i].x;
          y := temp_map.items[i].y;
          z := 2;
          Width := image.Width;
          height := image.Height;
        end;

    end;
  end;


  for i := 1 to number_of_players do //es werden immer 2 Player erzeugt. wenn man im singleplayermodus ist, wird leben des zweiten auf 0 gesetzt
    if player[i].leben > 0 then //nur wenn der player noch ein leben hat
    begin
      Player[i].sprite := TPlayerSprite.Create(DXSpriteEngine.Engine);
      player[i].killed := false;
      player[i].leben_weggenommen := false;
      with TPlayersprite(Player[i].sprite) do
      begin
        player_nr := i;
        Image := ImageList.Items.Find('Player_' + inttostr(i) + '_r');
        x := 800 - image.width;
        y := 600 - image.Height - 10;
        Z := 3; {abgehoben (Z Dimension (3d!!!))}
        Width := Image.Width;
        Height := Image.Height;
      end;
    end;
  erstemal_dieses_level := false;
  erstemal_dieses_game := false;
end;


procedure txp38sprite.movement;
var schrittx, schritty, ytogo, xtogo: integer;
begin
  ytogo := abs(yimp div 10);
  xtogo := abs(ximp);
  if xtogo <> 0 then
    schrittx := ximp div xtogo {1 oder -1}
  else schrittx := 0;
  if ytogo <> 0 then
    schritty := (yimp div 10) div ytogo {1 oder -1}
  else schritty := 0;

  while (xtogo > 0) or (ytogo > 0) do
  begin
    coll := false;
    if xtogo > 0 then
    begin
      x := x + 3 * schrittx;
      collision;
      if coll or (x < 0) or (x + width > form1.draw.SurfaceWidth) then
      begin
        x := x - 3 * schrittx;
        xtogo := 0;
      end
      else dec(xtogo, 3);
    end;
    coll := false;
    if ytogo > 0 then
    begin
      y := y + 3 * schritty;
      collision;
      if coll or (y < 0) then
      begin
        gesprungen := false;
        y := y - 3 * schritty;
        ytogo := 0;
        yimp := 0;
        if schritty < 0 then beule := true
        else beule := false;
      end else
        if (y + height > form1.draw.SurfaceHeight) and collisioned then
        begin
//          form1.dxwavelist.items.find('expl').pan := integer((20000 * round(x)) div 800) - 10000;
          PlaySound('expl', False);
          Collisioned := False;
    {  Image change  }
          Image := Form1.ImageList.Items.Find('explosion');
          Width := Image.Width;
          Height := Image.Height;
          AnimCount := 5;
          AnimLooped := false;
          AnimSpeed := 500 / 1000;
          AnimPos := 0;
        end
        else dec(ytogo, 3);
    end;
  end;
end;


{PLAYERSPRITE PROCEDUREN}

procedure TPlayersprite.DoCollision(Sprite: TSprite; var Done: Boolean);
var a: integer;
  ok: boolean;
begin
  if Sprite is therzSprite then
  begin
    ok := false;
    a := 1;
    repeat // for to Schleife ghet nicht!!
      if (herz[a].x = sprite.x) and (herz[a].y = sprite.y) then
      begin
        sprite.dead; //sieht sprite zum killen durch dxspriteengine.dead vor
        herz[a].sprite := nil;
        ok := true;
      end;
      inc(a);
    until (a = 100) or ok;

    sprite.collisioned := false; //Sprite kann nicht mehr kollidiern (nur bis xspriteengine.dead ausgefhrt wird wichtig, danach sowieso klar)
    inc(player[player_nr].punkte, 50);
    playsound('herz', false);
    if (player[player_nr].punkte mod 5000) = 0 then
    begin
      inc(player[player_nr].leben, 5);
      playsound('extra', false);
    end;
    if stone_left > 0 then
      dec(stone_left);
     {else}
  end;
  if sprite is TPlattformSprite then
  begin
    coll := true;
  end; //collision mit plattform
  if sprite is tumkehrsteinsprite then
  begin
    umkehr := true;
    playsound('diamrot', false);
    umkehrstein.sprite := nil;
    sprite.dead;
    sprite.collisioned := false;
    umkehrstein.zeit := gettickcount;
  end;
  if sprite is trubinsprite1 then
  begin
    ok := false;
    a := 1;
    repeat // for to Schleife ghet nicht!!
      if (rubin1[a].x = sprite.x) and (rubin1[a].y = sprite.y) and not (rubin1[a].sprite = nil) then
      begin
        inc(player[player_nr].health, 5);
        inc(player[player_nr].punkte, 25);
        playsound('diam', false);
        sprite.dead; //sieht sprite zum killen durch dxspriteengine.dead vor
        rubin1[a].sprite := nil;
        ok := true;
      end;
      inc(a);
    until (a = 100) or ok;
  end;

  if sprite is trubinsprite2 then
  begin
    ok := false;
    a := 1;
    repeat // for to Schleife ghet nicht!!
      if (rubin2[a].x = sprite.x) and (rubin2[a].y = sprite.y) and not (rubin2[a].sprite = nil) then
      begin
        inc(player[player_nr].health, 10);
        inc(player[player_nr].punkte, 25);
        playsound('diam', false);
        sprite.dead; //sieht sprite zum killen durch dxspriteengine.dead vor
        rubin2[a].sprite := nil;
        ok := true;
      end;
      inc(a);
    until (a = 100) or ok;
  end;

  if sprite is trubinsprite3 then
  begin
    ok := false;
    a := 1;
    repeat // for to Schleife ghet nicht!!
      if (rubin3[a].x = sprite.x) and (rubin3[a].y = sprite.y) and not (rubin3[a].sprite = nil) then
      begin
        inc(player[player_nr].health, 15);
        inc(player[player_nr].punkte, 25);
        playsound('diam', false);
        sprite.dead; //sieht sprite zum killen durch dxspriteengine.dead vor
        rubin3[a].sprite := nil;
        ok := true;
      end;
      inc(a);
    until (a = 100) or ok;
  end;



  if player[player_nr].health >= 100 then
  begin
    inc(player[player_nr].leben);
    playsound('extra', false);
    player[player_nr].health := 0;
  end;
  if (sprite is tRoboSprite) or (sprite is tRobokannoneSprite)
    or (sprite is tfreiRobosprite) or (sprite is tflugRobosprite) or
    (sprite is tRobolinksrechtssprite) or (sprite is tRobolinksrechtssprite2) or (sprite is tstachelsprite) then
  begin
//    form1.dxwavelist.items.find('expl').pan := integer(20000 * round(x) div 800) - 10000;
    PlaySound('expl', False);
    Collisioned := False;
    {  Image change  }
    Image := Form1.ImageList.Items.Find('explosion');
    Width := Image.Width;
    Height := Image.Height;
    AnimCount := 5;
    AnimLooped := false;
    AnimSpeed := 500 / 1000;
    AnimPos := 0;
  end;
  done := false; //Das khrt so...
end;




//chris

procedure TPlayerSprite.DoMove(MoveCount: Integer);
begin
  inherited DoMove(MoveCount); {Besonders wichtig !!!}
  ximp := 0;
  if player_nr = 1 then
  begin
    if (isDown in Form1.DXInput.States) then inc(yimp, round(impuls * 50))
    else inc(yimp, round(impuls * gravbasis)); //der 2. Parameterbestimmt,wie stark die Grav ist.
    if not (isUp in Form1.DXInput.States) and (yimp <> round(impuls * gravbasis)) then
      gesprungen := true;

    //schnell und laufen
    if not beule and (isUp in Form1.DXInput.States) and ((isleft in form1.DXInput.States) or (isright in form1.dxinput.states)) and not gesprungen then
    begin
      if yimp = round(impuls * gravbasis) then
        maxheight := y - 80;
      if y > maxheight then yimp := round(impuls * -160)
      else beule := true;
    end

    else

    //langsam und laufen
      if not beule and (isUp in Form1.DXInput.States) and ((isleft in form1.DXInput.States) or (isright in form1.dxinput.states)) and (isbutton10 in form1.DXInput.States) and not gesprungen then
      begin
        if yimp = round(impuls * gravbasis) then
          maxheight := y - 70;
        if y > maxheight then yimp := round(impuls * -130)
        else beule := true;
      end

      else

    //schnell und stehen
        if not beule and (isUp in Form1.DXInput.States) and not gesprungen then
        begin
          if yimp = round(impuls * gravbasis) then
            maxheight := y - 65;
          if y > maxheight then yimp := round(impuls * -120)
          else beule := true;
        end;

    if umkehr and (gettickcount > umkehrstein.zeit + 10000) then umkehr := false;
    if (isLeft in Form1.DXInput.States) and (isbutton10 in form1.DXInput.States) then
      if not umkehr then Ximp := -1
      else ximp := 1
    else if (isLeft in Form1.DXInput.States) then
      if not umkehr then Ximp := -xschritt
      else ximp := xschritt;

    if (isRight in Form1.DXInput.States) and (isbutton10 in form1.DXInput.States) then
      if not umkehr then Ximp := 1
      else ximp := -1
    else if (isRight in Form1.DXInput.States) then
      if not umkehr then Ximp := xschritt
      else ximp := -xschritt;

  end;


  if player_nr = 2 then
  begin
    if (isbutton8 in Form1.DXInput.States) then inc(yimp, round(impuls * 50))
    else inc(yimp, round(impuls * gravbasis)); //der 2. Parameterbestimmt,wie stark die Grav ist.
    if not (isButton4 in Form1.DXInput.States) and (yimp <> round(impuls * gravbasis)) then
      gesprungen := true;

    //schnell und laufen
    if not beule and (isButton4 in Form1.DXInput.States) and ((isButton3 in form1.DXInput.States) or (isButton5 in form1.dxinput.states)) and not gesprungen then
    begin
      if yimp = round(impuls * gravbasis) then
        maxheight := y - 80;
      if y > maxheight then yimp := round(impuls * -160)
      else beule := true;
    end

    else

    //langsam und laufen
      if not beule and (isButton4 in Form1.DXInput.States) and ((isButton3 in form1.DXInput.States) or (isButton5 in form1.dxinput.states)) and (isButton7 in form1.DXInput.States) and not gesprungen then
      begin
        if yimp = round(impuls * gravbasis) then
          maxheight := y - 70;
        if y > maxheight then yimp := round(impuls * -130)
        else beule := true;
      end

      else

    //schnell und stehen
        if not beule and (isButton4 in Form1.DXInput.States) and not gesprungen then
        begin
          if yimp = round(impuls * gravbasis) then
            maxheight := y - 65;
          if y > maxheight then yimp := round(impuls * -120)
          else beule := true;
        end;

    if umkehr and (gettickcount > umkehrstein.zeit + 10000) then umkehr := false;
    if (isButton3 in Form1.DXInput.States) and (isButton7 in form1.DXInput.States) then
      if not umkehr then Ximp := -1
      else ximp := 1
    else if (isButton3 in Form1.DXInput.States) then
      if not umkehr then Ximp := -xschritt
      else ximp := xschritt;

    if (isButton5 in Form1.DXInput.States) and (isButton7 in form1.DXInput.States) then
      if not umkehr then Ximp := 1
      else ximp := -1
    else if (isButton5 in Form1.DXInput.States) then
      if not umkehr then Ximp := xschritt
      else ximp := -xschritt;
  end;


  if not (Image = Form1.ImageList.Items.Find('explosion')) then
  begin
    Animcount := 7;
    if ximp > 0 then image := form1.imagelist.items.find('Player_' + inttostr(player_nr) + '_r') //optimieren!!
    else if ximp < 0 then image := form1.imagelist.items.find('Player_' + inttostr(player_nr) + '_l')
    else if ximp = 0 then
    begin
      AnimCount := 0;
      if (image = form1.imagelist.items.find('Player_' + inttostr(player_nr) + '_l')) or (image = form1.imagelist.items.find('Player_' + inttostr(player_nr) + '_l_stand')) then image := form1.ImageList.Items.find('Player_' + inttostr(player_nr) + '_l_stand')
      else image := form1.ImageList.Items.find('Player_' + inttostr(player_nr) + '_r_stand')
    end;
    AnimLooped := True;
    AnimSpeed := 1000 / 1000;
    movement;
  end;
  if (animspeed = 0 {animation beendet}) and (Image = Form1.ImageList.Items.Find('explosion')) then
  begin
    player[player_nr].killed := true;
  end;
end;

procedure TRoboSprite.DoCollision(Sprite: TSprite; var Done: Boolean);
begin
  if sprite is TPlattformSprite then
  begin
    coll := true;
  end; //
 // collision mit plattform
  done := false; //Das khrt so...
end;


procedure TRobolinksrechtsSprite.DoCollision(Sprite: TSprite; var Done: Boolean);
begin // wandert von links nach rechts
  if sprite is TPlattformSprite then
  begin
    coll := true;
  end; //
 // collision mit plattform
  done := false; //Das khrt so...
end;


procedure TRobolinksrechtsSprite.DoMove(MoveCount: Integer);
begin
  inherited DoMove(MoveCount);
 //                   I       (nur nach spieler)
{  if (x < start)or(x<player[1].sprite.x) then ximp := 1;
  if (x + width + 10 >ende )or(x>player[1].sprite.x)
  and(x>start)then ximp := -1;         }
 //                  II       (nach weg)
  if (x < start.x + 1) then ximp := 1;
  if (x > ende.x - 1) then ximp := -1;

  if ximp > 0 then image := form1.imagelist.items.find('wurm_r')
  else image := form1.imagelist.items.find('wurm_l');
  AnimCount := image.PatternCount; {Die Sachen kommen jetzt hier rein !!}
  if ximp = 0 then animcount := 0;
  AnimLooped := True;
  AnimSpeed := 500 / 1000;
  movement;

end;

procedure TRobolinksrechtsSprite2.DoCollision(Sprite: TSprite; var Done: Boolean);
begin // wandert von links nach rechts
  if sprite is TPlattformSprite then
  begin
    coll := true;
  end; //
 // collision mit plattform
  done := false; //Das khrt so...
end;


procedure TRobolinksrechtsSprite2.DoMove(MoveCount: Integer);
var dcspieler1, dbspieler1, dcspieler2, dbspieler2, dabstand1, dabstand2: real;
  dspieler: integer;

begin
  inherited DoMove(MoveCount);

  if number_of_players = 1 then begin

 //                   I       (nur nach spieler)
    if (x < start.x) or (x < player[1].sprite.x) then ximp := 1;
    if (x + width + 10 > ende.x) or (x > player[1].sprite.x)
      and (x > start.x) then ximp := -1;


    if ximp > 0 then image := form1.imagelist.items.find('kaefer_r')
    else image := form1.imagelist.items.find('kaefer_l');
    Animcount := 4;
    if ximp = 0 then animcount := 0;
  end //player1
  else
  begin
    dcspieler1 := round(sqr(abs(x - player[1].sprite.x)));
    dbspieler1 := round(sqr(abs(y - player[1].sprite.y)));
    dcspieler2 := round(sqr(abs(x - player[2].sprite.x)));
    dbspieler2 := round(sqr(abs(y - player[2].sprite.y)));
    dabstand1 := dcspieler1 + dbspieler1;
    dabstand2 := dcspieler2 + dbspieler2;
    if (dabstand1 < dabstand2) and (player[1].killed = false) then dspieler := 1
    else dspieler := 2;
    if (player[1].killed = false) and (player[2].killed = true) then dspieler := 1;

    if (x < start.x) or (x < player[dspieler].sprite.x) then ximp := 1;
    if (x + width + 10 > ende.x) or (x > player[dspieler].sprite.x)
      and (x > start.x) then ximp := -1;


    if ximp > 0 then image := form1.imagelist.items.find('kaefer_r')
    else image := form1.imagelist.items.find('kaefer_l');
    Animcount := 4;
    if ximp = 0 then animcount := 0;
  end;

  AnimLooped := True;
  AnimSpeed := 1000 / 1000;
  AnimStart := 0;
  movement;
end;



procedure TRoboSprite.DoMove(MoveCount: Integer); //ist im Spiel ?????
var i, ccspieler1, cbspieler1, ccspieler2, cbspieler2, cabstand1, cabstand2: real;
  cspieler: integer;
begin
  inherited DoMove(MoveCount); {Besonders wichtig !!!}
  inc(yimp, grav); {hier stimmt was nicht, jens}
  if number_of_players = 1 then
  begin
    if coll = true then begin
      if player[1].sprite.x < x then ximp := -2
      else ximp := 2;
      if player[1].sprite.y < y then yimp := -20
      else yimp := 20;
    end
    else begin
      if player[1].sprite.x < x then ximp := -2
      else ximp := 2;
      if player[1].sprite.y < y then yimp := -20
      else yimp := 20;
    end;
    if ximp > 0 then image := form1.imagelist.items.find('drache_r')
    else image := form1.imagelist.items.find('drache_l');
    AnimCount := 6; {Die Sachen kommen jetzt hier rein !!}
    if ximp = 0 then animcount := 0;
  end //player1
  else
  begin
    ccspieler1 := round(sqr(abs(x - player[1].sprite.x)));
    cbspieler1 := round(sqr(abs(y - player[1].sprite.y)));
    ccspieler2 := round(sqr(abs(x - player[2].sprite.x)));
    cbspieler2 := round(sqr(abs(y - player[2].sprite.y)));
    cabstand1 := ccspieler1 + cbspieler1;
    cabstand2 := ccspieler2 + cbspieler2;
    if (cabstand1 < cabstand2) and (player[1].killed = false) then cspieler := 1
    else cspieler := 2;
    if (player[1].killed = false) and (player[2].killed = true) then cspieler := 1;
    if coll = true then begin
      if player[cspieler].sprite.x < x then ximp := -2
      else ximp := 2;
      if player[cspieler].sprite.y < y then yimp := -20
      else yimp := 20;
    end
    else begin
      if player[cspieler].sprite.x < x then ximp := -2
      else ximp := 2;
      if player[cspieler].sprite.y < y then yimp := -20
      else yimp := 20;
    end;
    if ximp > 0 then image := form1.imagelist.items.find('drache_r')
    else image := form1.imagelist.items.find('drache_l');
    AnimCount := 6; {Die Sachen kommen jetzt hier rein !!}
    if ximp = 0 then animcount := 0;
  end; //player2


  AnimLooped := True;
  AnimSpeed := 100 / 1000;
  AnimStart := 0;
  movement;
end;

procedure TflugRobosprite.DoCollision(Sprite: TSprite; var Done: Boolean); //der freie Vogel
begin
  if sprite is TPlattformSprite then
  begin
    coll := true;
  end; //
 // collision mit plattform
  done := false; //Das khrt so...
end;

procedure TflugRoboSprite.DoMove(MoveCount: Integer); //der freie Vogel
var xli, xrech, i, cspieler1, bspieler1, cspieler2, bspieler2, abstand1, abstand2: real;
  spieler: integer;
begin //den ximp betrachten und danch grafik laden
  inherited DoMove(MoveCount); {Besonders wichtig !!!}
  inc(yimp, grav); {hier stimmt was nicht, jens}
  if number_of_players = 1 then
  begin //spieler1;
    xli := player[1].sprite.x - 1;
    xrech := player[1].sprite.x + 1;
    if {(x<xrech)and(x>xli)and}(player[1].sprite.y <> y) and (player[1].sprite.ximp = 0) and
      (coll = true) then
    begin
      if x < form1.draw.SurfaceWidth - 100 then
      begin
//       image := form1.imagelist.items.find('gegner1_l');
        ximp := -1;
      end
      else
      begin
        ximp := 1;
//       image := form1.imagelist.items.find('gegner1_r');
        i := 1;
      end;
    end
    else begin
      if coll = true then begin
        if player[1].sprite.x < x then ximp := -1
        else ximp := 1;
        if player[1].sprite.y < y then yimp := -10
        else yimp := 10;
      end
      else begin
        if player[1].sprite.x < x then ximp := -1
        else ximp := 1;
        if player[1].sprite.y < y then yimp := -10
        else yimp := 10;
      end;
    end;

  end //Player1
  else
  begin //player2
    cspieler1 := round(sqr(abs(x - player[1].sprite.x)));
    bspieler1 := round(sqr(abs(y - player[1].sprite.y)));
    cspieler2 := round(sqr(abs(x - player[2].sprite.x)));
    bspieler2 := round(sqr(abs(y - player[2].sprite.y)));
    abstand1 := cspieler1 + bspieler1;
    abstand2 := cspieler2 + bspieler2;
    if (abstand1 < abstand2) and (player[1].killed = false) then spieler := 1
    else spieler := 2;
    if (player[1].killed = false) and (player[2].killed = true) then spieler := 1;
 //   xli:=player[1].sprite.x-1;
  //  xrech:=player[1].sprite.x+1;
    if {(x<xrech)and(x>xli)and}(player[spieler].sprite.y <> y) and (player[spieler].sprite.ximp = 0) and
      (coll = true) then
    begin
      if x < form1.draw.SurfaceWidth - 100 then
      begin
//       image := form1.imagelist.items.find('gegner1_l');
        ximp := -1;
      end
      else
      begin
        ximp := 1;
//       image := form1.imagelist.items.find('gegner1_r');
        i := 1;
      end;
    end
    else begin
      if coll = true then begin
        if player[spieler].sprite.x < x then ximp := -1
        else ximp := 1;
        if player[spieler].sprite.y < y then yimp := -10
        else yimp := 10;
      end
      else begin
        if player[spieler].sprite.x < x then ximp := -1
        else ximp := 1;
        if player[spieler].sprite.y < y then yimp := -10
        else yimp := 10;
      end;
    end;
  end; //player2

  if ximp > 0 then image := form1.imagelist.items.find('gegner1_r')
  else image := form1.imagelist.items.find('gegner1_l');
  AnimCount := image.PatternCount; {Die Sachen kommen jetzt hier rein !!}
  if ximp = 0 then animcount := 0;
  AnimLooped := True;
  AnimSpeed := 100 / 1000;
  AnimStart := 0;
  movement;
end;




procedure TfreiRobosprite.DoCollision(Sprite: TSprite; var Done: Boolean); //der Falke
begin
  if sprite is TPlattformSprite then
  begin
    coll := true;
  end; //
 // collision mit plattform
  done := false; //Das khrt so...
end;

procedure TfreiRobosprite.DoMove(MoveCount: Integer); //der Falke
var i, acspieler1, abspieler1, acspieler2, abspieler2, aabstand1, aabstand2: real;
  aspieler: integer;
begin
  inherited DoMove(MoveCount); {Besonders wichtig !!!}
  if number_of_players = 2 then
  begin
    acspieler1 := round(sqr(abs(x - player[1].sprite.x)));
    abspieler1 := round(sqr(abs(y - player[1].sprite.y)));
    acspieler2 := round(sqr(abs(x - player[2].sprite.x)));
    abspieler2 := round(sqr(abs(y - player[2].sprite.y)));
    aabstand1 := acspieler1 + abspieler1;
    aabstand2 := acspieler2 + abspieler2;
    if (aabstand1 < aabstand2) and (player[1].killed = false) then aspieler := 1
    else aspieler := 2;
  end
  else
    aspieler := 1;


  inc(yimp, grav);
  begin
    if (y > form1.draw.Surface.Height - 100) and (nachunten = 0) then
    begin nachunten := gettickcount; nachoben := 0; end
    else
      if (y < 100) and (nachoben = 0) then
      begin
        nachoben := gettickcount;
        nachunten := 0;
        ja := false;
      end;
    if (gettickcount - 2500 > nachunten) and (nachoben = 0) then
    begin
      yimp := -10;
    end;

    if (coll = true) and (gettickcount - 20000 > nachoben) then
    begin
      yimp := -10;
      ja := true;
      nachoben := 0;
    end;

    if coll = true then begin y := y - 20; end;

    if y < 150 then begin if x < player[aspieler].sprite.x then ximp := 1
      else ximp := -1;
      ja := false;
    end;
    if (y > 100) and (y < form1.draw.Surface.Height - 100) and (yimp > 0) and (y < player[aspieler].sprite.y + 50) then
    begin
      if x < player[aspieler].sprite.x then ximp := 1
      else ximp := -1;
    end;
    if (y > player[aspieler].sprite.y + 50) then ximp := 1;
    if (nachunten = 0) and (gettickcount - 5000 > nachoben) then yimp := 10
  end;

  if ximp > 0 then
    image := form1.imagelist.items.find('gegner2_r')
  else if ximp < 0 then
    image := form1.imagelist.items.find('gegner2_l');
  AnimCount := 7; {Die Sachen kommen jetzt hier rein !!}
  if ximp = 0 then
  begin
    animcount := 0;
  end;
  AnimLooped := True;
  AnimSpeed := 300 / 1000;
  AnimStart := 0;
  movement;
end;


procedure TRobokannonesprite.DoCollision(Sprite: TSprite; var Done: Boolean);
begin
  if sprite is TPlattformSprite then
  begin
    coll := true;
  end; //
 // collision mit plattform
  done := false; //Das khrt so...
end;

procedure TRobokannoneSprite.DoMove(MoveCount: Integer); //kannone neu
var i, bcspieler1, bbspieler1, bcspieler2, bbspieler2, babstand1, babstand2: real;
  bspieler: integer;
begin
  inherited DoMove(MoveCount); {Besonders wichtig !!!}

  if number_of_players = 2 then
  begin
    bcspieler1 := round(sqr(abs(x - player[1].sprite.x)));
    bbspieler1 := round(sqr(abs(y - player[1].sprite.y)));
    bcspieler2 := round(sqr(abs(x - player[2].sprite.x)));
    bbspieler2 := round(sqr(abs(y - player[2].sprite.y)));
    babstand1 := bcspieler1 + bbspieler1;
    babstand2 := bcspieler2 + bbspieler2;
    if (babstand1 < babstand2) and (player[1].killed = false) then bspieler := 1
    else bspieler := 2;
  end
  else
    bspieler := 1;
  movement;

  ximp := 1;
  inc(yimp, grav);
  if (coll = true) or (x > form1.Draw.SurfaceWidth - 30) then
  begin
    x := startpunkt.x;
    y := startpunkt.y; //startpunkte der Kannone
    playsound('kanone', false);
  end;

  begin
    if (y < player[bspieler].sprite.y + 5) and (y > player[bspieler].sprite.y - 5) then yimp := 0
    else
    begin
      if (player[bspieler].sprite.y < y) then yimp := -10
      else yimp := 10;
    end;
  end;
end;


procedure TForm1.BlinkStart;
begin
  FBlink := 0;
  FBlinkTime := GetTickCount;
end;

procedure tForm1.BlinkUpdate;
begin
  if GetTickCount <> FBlinkTime then
  begin
    FBlink := FBlink + (GetTickCount - FBlinkTime);
    FBlinkTime := GetTickCount;
  end;
end;


procedure tform1.StartScene(Scene: TGameScene);
begin
  EndScene;
  FScene := Scene;
  BlinkStart;
  case FScene of
    gsTitle: StartSceneTitle;
    gsmain: if not (fsceneprevious = gsmenu) then StartScenemain;
    gsGameOver: StartSceneGameOver;
    gsMenu: StartSceneMenu;
  end;
end;

procedure tform1.StartSceneTitle;
begin
  firsttickcount := gettickcount;
  if textart = 0 then
    playmidi('intro', true)
  else
    playmidi('credits', true);
  scrollbetrag := 0;
end;

procedure tform1.StartSceneMain;
begin
  dxSpriteEngine.Engine.Clear;
  levelinit;
  firsttickcount := gettickcount;
  sleep(500);
end;

procedure tform1.StartSceneGameOver;
var tempHighScoreTable: ttable;
  datei: file of ttable;
  i, j, temp_index, index, player_nummer: byte;
  eingetragen: boolean;
  minuten, sekunden: array[1..2] of byte;
begin
  gameoverscenestartzeit := gettickcount;
  minuten[1] := player[1].spielzeit div 60;
  sekunden[1] := player[1].spielzeit mod 60;
  minuten[2] := player[2].spielzeit div 60;
  sekunden[2] := player[2].spielzeit mod 60;
  {  Game over scene beginning  }
  playmidi('gameover', true);
  //hier werden die High Scores geladen und gespeichert
  if fileexists('table.mid') then
  try
    assignfile(datei, 'table.mid');
    Reset(datei);
    read(datei, HighScoreTable)
  except
  end;
  //dekodieren
  for i := 1 to 10 do
  begin
    for j := 1 to length(highscoretable[i].name) do
      highscoretable[i].name[j] := chr(ord(highscoretable[i].name[j]) - 10);
    highscoretable[i].punkte := highscoretable[i].punkte;
    highscoretable[i].minuten := highscoretable[i].minuten;
    highscoretable[i].sekunden := highscoretable[i].sekunden;
  end;
  // neuen table generieren
  if usermap = '' then
  begin
    for player_nummer := 1 to number_of_players do
    begin
      eingetragen := false;
      index := 1;
      for temp_index := 1 to 10 do
        if (highscoretable[index].punkte > player[player_nummer].punkte) or ((highscoretable[index].punkte = player[player_nummer].punkte) and (60 * highscoretable[index].minuten + highscoretable[index].sekunden <= 60 * minuten[player_nummer] + sekunden[player_nummer])) or eingetragen then
        begin //alten bernehmen
          tempHighScoreTable[temp_index].punkte := HighScoreTable[index].punkte;
          tempHighScoreTable[temp_index].name := HighScoreTable[index].name;
          tempHighScoreTable[temp_index].minuten := HighScoreTable[index].minuten;
          tempHighScoreTable[temp_index].sekunden := HighScoreTable[index].sekunden;
          inc(index);
        end
        else
        begin
          tempHighScoreTable[temp_index].punkte := player[player_nummer].punkte;
          tempHighScoreTable[temp_index].name := player[player_nummer].name;
          tempHighScoreTable[temp_index].minuten := minuten[player_nummer];
          tempHighScoreTable[temp_index].sekunden := sekunden[player_nummer];
          eingetragen := true;
        end;
      HighScoreTable := tempHighScoreTable;
    end;
// neuen table speichern
    for i := 1 to 10 do
    begin
      for j := 1 to length(highscoretable[i].name) do
        highscoretable[i].name[j] := chr(ord(highscoretable[i].name[j]) + 10);
      highscoretable[i].punkte := highscoretable[i].punkte;
      highscoretable[i].minuten := highscoretable[i].minuten;
      highscoretable[i].sekunden := highscoretable[i].sekunden;
    end;

    try
      assignfile(datei, 'table.mid');
      Rewrite(datei);
      write(datei, highscoretable);
      closefile(datei);
    except
      MessageDlg('Some errors occured during saving!', mtError, [mbOK], 0);
    end;
//statt dekodieren den neu generierten Table wieder zuweisen
    HighScoreTable := tempHighScoreTable;
  end;
end;

procedure tform1.StartSceneMenu;
begin
  currentselecteditem := 1;
  currentmenu := 0;
end;

procedure tform1.EndScene;
begin
  case FScene of
    gsTitle: EndSceneTitle;
    gsMain: EndScenemain;
    gsGameOver: EndSceneGameOver;
    gsMenu: EndSceneMenu;
  end;
end;

procedure tform1.EndSceneTitle;
begin
  {  Title scene end  }
  textart := 0;
end;


procedure tform1.EndSceneMain;
begin
  {  Main scene end  }
  currentfps := dxtimer1.framerate;
end;


procedure tform1.EndSceneGameOver;
begin
  {  Game over scene end  }
  gameoverSceneMessageNr := 0;
end;

procedure tform1.EndSceneMenu;
begin
end;

procedure tform1.SceneTitle;
var
  Logo: TPictureCollectionItem;
  i: byte;
  pos, posx, endeDesTextes: integer;
begin
  {  Title scene  }
  Draw.Surface.Fill(0);
  with Draw.Surface.Canvas do
  begin
    Brush.Style := bsClear;
    Font.Color := clred;
    Font.Size := 15;
    Font.Name := 'Arial';
    if currentfps = 0 then currentfps := 10;
    if textart = 0 then
    begin
      scrollbetrag := scrollbetrag + (8 / currentfps);
      if scrollbetrag > 1400 then
      begin
        scrollbetrag := 0;
        playmidi('intro', false);
      end;
    end
    else
    begin
      scrollbetrag := scrollbetrag + (16 / currentfps);
      if scrollbetrag > 1800 then
      begin
        scrollbetrag := 0;
        textart := 0;
        playmidi('intro', false);
      end;
    end;

    if textart = 0 then
    begin
      posx := 50;
      endeDesTextes := 52;
    end
    else
    begin
      posx := 200;
      endeDesTExtes := 66;
    end;
    for i := 1 to endeDesTextes do
    begin
      pos := 530 + i * 20 - round(scrollbetrag);
      if (pos < 540) and (pos > 200) then textout(posx, pos, atext[textart].line[i])
    end;
    if (FBlink div 300) mod 2 = 0 then
    begin
      Font.Color := clWhite;
      Font.Size := 30;
      Font.Name := 'Arial';
      Textout(260, 546, 'PUSH Space Bar')
    end;
    BlinkUpdate;
    Release;
  end;
  ImageList.Items.find('title1').draw(draw.surface, 0, 194, 0);
  ImageList.Items.find('title1').draw(draw.surface, 0, 540, 0);
  Logo := ImageList.Items.find('title');
  Logo.DrawWaveX(Draw.Surface, 180, 20, Logo.Width, Logo.Height, 0,
    Trunc(16 - Cos256(FBlink div 60) * 16), 32, -FBlink div 5);

  with Draw.Surface.Canvas do
  begin
    if (FBlink div 300) mod 2 = 0 then
    begin
      Font.Color := clWhite;
      Font.Size := 30;
      Font.Name := 'Arial';
      Textout(260, 546, 'PUSH Space Bar')
    end;
    BlinkUpdate;
    Release;
  end;

  if (isButton1 in DXInput.States) then
  begin
    startscene(gsmenu);
    playsound('boom', false);
  end;
end;

procedure tform1.SceneMenu;
//MENU
const
  xv = 80;
  yv = -65;
  xsv = -130;
var i: integer;
begin
  draw.surface.fill(0);
  ImageList.Items.find('title').draw(draw.surface, 180, 20, 0);
  with Draw.Surface.Canvas do
  begin
    Brush.Style := bsClear;
    Font.Color := clred;
    Font.Size := 27;
    Font.Name := 'Arial';
    if currentmenu = 1 then
      Textout(260 + xv + xsv, 290 + yv, amenu[currentmenu].name)
    else
      Textout(260 + xv, 290 + yv, amenu[currentmenu].name);
    for i := 1 to amenu[currentmenu].number_of_items do
    begin
      Brush.Style := bsClear;
      if i <> currentselecteditem then
      begin
        Font.Color := clwhite;
        Font.Size := 16;
      end
      else
      begin
        Font.Color := clred;
        Font.Size := 17;
      end;
      Font.Name := 'Arial';
      if currentmenu = 1 then
        Textout(230 + xv + xsv, 300 + yv + i * 25, amenu[currentmenu].item[i].name)
      else
        Textout(230 + xv, 300 + yv + i * 25, amenu[currentmenu].item[i].name);
    end;
    Brush.Style := bsClear;
    Font.Color := clred;
    Font.Size := 17;
    Font.Name := 'Arial';
    if (currentmenu = 1) then
      for i := 1 to 2 do
      begin
        Font.Color := clred;
        if (currentselecteditem = i) and (dont_move) then
          Font.Color := clwhite;
        Textout(350 + xv + xsv, 300 + yv + i * 25, player[i].name);
      end;
    if (currentmenu = 3) then
    begin
      if not dont_move then font.color := clwhite;
      if usermap <> '' then Textout(350 + xv, 325 + yv, usermap) else
        Textout(350 + xv, 325 + yv, '<No Usermap>')
    end;
    Release;
  end;
end;

procedure tform1.Scenemain;
var msg: string[35];
  i: integer;
begin
  DXSpriteEngine.Move(1); //Alles wird bewegt, wenn auch um 0 Pixel, aber fr Prog gab es eine bewegung (wichtig fr kollision: collision wird gerufen)
  Draw.Surface.Fill(0); //Hintergrund: schwarz
  DXSpriteEngine.dead; //entfernt die toten Sprites
//Punktestand etc
if amenu[0].item[9].name = 'Backgrounds: ON' then  ImageList.Items.find(inttostr(bgindex)).draw(draw.surface, 0, 0, 0);
  ImageList.Items.find('rahmen').draw(draw.surface, 0, 0, 0);
  with Draw.Surface.Canvas do
  begin
    Brush.Style := bsClear;
    Font.Color := clred;
    Font.Size := 10;
    Font.Name := 'Arial';
    Textout(10, 1, Player[1].name);
    msg := 'Score: ' + inttostr(player[1].punkte);
    Textout(170, 1, msg);
    msg := 'Health: ' + inttostr(player[1].health);
    Textout(260, 1, msg);
    msg := 'Lives:  ' + inttostr(player[1].leben);
    Textout(333, 1, msg);
    if number_of_players = 2 then
    begin
      Textout(410, 1, Player[2].name);
      msg := 'Score: ' + inttostr(player[2].punkte);
      Textout(570, 1, msg);
      msg := 'Health: ' + inttostr(player[2].health);
      Textout(660, 1, msg);
      msg := 'Lives:  ' + inttostr(player[2].leben);
      Textout(733, 1, msg);
    end;
    if paramstr(1) = '-debug' then
    begin
      msg := 'currentFPS:  ' + inttostr(currentfps);
      Textout(10, 180, msg);
      msg := 'timer.FPS:  ' + inttostr(dxtimer1.framerate);
      Textout(10, 200, msg);
      msg := 'Yimp  ' + inttostr(player[1].sprite.yimp);
      Textout(10, 220, msg);
      msg := 'y ' + inttostr(round(player[1].sprite.y));
      Textout(10, 240, msg);
      msg := 'mh ' + inttostr(round(maxheight));
      textout(10, 260, msg);
      msg := 'impuls *100 ' + inttostr(round(impuls * 100));
      textout(10, 280, msg);
      msg := 'xschritt ' + inttostr(xschritt);
      textout(10, 300, msg);
    end;
    Release;
  end;
  DXSpriteEngine.Draw; //Zeichnen im Hintergrund (Grafikkartenspeicher)
  if stone_left = 0 then
  begin
    lastfps := dxtimer1.framerate;
    inc(level);
    erstemal_dieses_level := true;
    FNextScene := gsmain;
    draw.flip;
  end;
  for i := 1 to number_of_players do
    if player[i].killed then
    begin
      if not player[i].leben_weggenommen then
      begin
        dec(player[i].leben);
        player[i].sprite.dead;
        player[i].leben_weggenommen := true;
        if player[i].leben < 1 then
        begin
          player[i].spielzeit := (gettickcount - startzeit) div 1000; //sekunden
        end;
      end;
    end;
  if player[1].killed and (player[2].killed or (number_of_players = 1)) then
  begin
    FNextScene := gsmain; //level neu starten
  end;
  if (player[1].leben < 1) and ((player[2].leben < 1) or (number_of_players = 1)) then
  begin
    fnextScene := gsgameover;
  end;
end;



procedure tform1.SceneGameOver;
var pos, i: Integer;
  currentsek: string[2];
begin
  if gameoverscenestartzeit + 42000 < gettickcount then
  begin
    textart := 1; //credits
    startscene(gstitle);
  end;
  {  Game over scene  }
  Draw.Surface.Fill(0);
  with Draw.Surface.Canvas do
  begin
    Brush.Style := bsClear;
    Font.Color := clRed;
    Font.Name := 'Arial';
    case gameoverSceneMessageNr of
      0:
        begin
          Font.Size := 40;
          Textout(240, 100, 'Game Over');
        end;
      1:
        begin
          Font.Size := 16;
          Textout(40, 100, 'It was not possible to find the usermap!');
        end;
      2:
        begin
          Font.Size := 16;
          Textout(130, 50, 'Congratulations! You survived the adventure!');
          Textout(130, 80, 'We did not expect anyone to make it, therefore,');
          Textout(130, 100, 'here is no ending sequence! (We werent able to');
          Textout(130, 120, 'afford it, anyway; Donate us money! http://Back2D.2XS.net)');
        end;
    end; {of case}

    font.size := 10;
    for i := 0 to 9 do
    begin
      textout(200, 160 + (i * 20), highscoretable[i + 1].name);
      textout(410, 160 + (i * 20), inttostr(highscoretable[i + 1].punkte));
      if highscoretable[i + 1].minuten > 9 then
        pos := 518
      else
        pos := 525;
      textout(pos, 160 + (i * 20), inttostr(highscoretable[i + 1].minuten));
      textout(532, 160 + (i * 20), ':');
      if highscoretable[i + 1].sekunden < 10 then currentsek := '0' + inttostr(highscoretable[i + 1].sekunden) else currentsek := inttostr(highscoretable[i + 1].sekunden);
      textout(535, 160 + (i * 20), currentsek);
    end;
    if (FBlink div 300) mod 2 = 0 then
    begin
      Font.Color := clWhite;
      Font.Size := 30;
      Font.Name := 'Arial';
      Textout(120, 500, 'PUSH Space Bar to Restart')
    end;
    Release;
    BlinkUpdate;
  end;
  if (isButton1 in DXInput.States) then
    newgame;
end;



procedure TForm1.FormCreate(Sender: TObject);
var musik, effekte: boolean;
begin
  randomize;
  lastkey := '*';
  number_of_thiskey := 0;
  currentusermapindex := 255;
  fsceneprevious := gstitle;
  eigenemaps := false;
  textart := 0;
  try
    configu := tinifile.Create(extractfilepath(paramstr(0)) + 'xp38.ini');
    player[1].name := configu.readString('Main', 'Player1Name', 'Nameless');
    player[2].name := configu.readString('Main', 'Player2Name', 'Nameless 2');
    lastfps := configu.readInteger('Main', 'LastFPS', 10);
    usermap := configu.readstring('Main', 'Usermap', '');
    dovollbild := configu.readbool('Main', 'Vollbild', False);
    musik := configu.readbool('Main', 'Musik', true);
    effekte := configu.readbool('Main', 'Effekte', true);
  except
  end;
  currentselecteditem := 1;
  currentmenu := 0;
  amenu[0].name := 'Main';
  amenu[0].item[1].name := 'New Game (F2)';
  amenu[0].item[1].next_menu := 248;
  amenu[0].item[2].name := 'Play own maps';
  amenu[0].item[2].next_menu := 244;
  amenu[0].item[3].name := 'Playername';
  amenu[0].item[3].next_menu := 1;
  amenu[0].item[4].name := 'Sound';
  amenu[0].item[4].next_menu := 2;
  amenu[0].item[5].name := 'User Map';
  amenu[0].item[5].next_menu := 3;
  amenu[0].item[6].name := 'Multiplayer: OFF';
  amenu[0].item[6].next_menu := 255; //Prozedur wird aufgerufen wenn grer als 127
  amenu[0].item[7].name := 'Full Screen: OFF (F4)';
  amenu[0].item[7].next_menu := 249; //Prozedur wird aufgerufen wenn grer als 127
  amenu[0].item[8].name := '3D Acceleration: OFF';
  amenu[0].item[8].next_menu := 246; //Prozedur wird aufgerufen wenn grer als 127
  amenu[0].item[9].name := 'Backgrounds: ON';
  amenu[0].item[9].next_menu := 242; //Prozedur wird aufgerufen wenn grer als 127
  amenu[0].item[10].name := 'Credits';
  amenu[0].item[10].next_menu := 245; //Prozedur wird aufgerufen wenn grer als 127
  amenu[0].item[11].name := 'Load Savestate';
  amenu[0].item[11].next_menu := 243; //Prozedur wird aufgerufen wenn grer als 127
  amenu[0].item[12].name := 'Quit Game (ALT+F4)';
  amenu[0].item[12].next_menu := 254; //Prozedur wird aufgerufen wenn grer als 127
  amenu[0].number_of_items := 12;
  amenu[0].prev_menu := 255;


  amenu[1].name := 'Enter Playername';
  amenu[1].item[1].name := 'Player 1:';
  amenu[1].item[1].next_menu := 253; //Prozedur wird aufgerufen wenn grer als 127
  amenu[1].item[2].name := 'Player 2:';
  amenu[1].item[2].next_menu := 252; //Prozedur wird aufgerufen wenn grer als 127
  amenu[1].number_of_items := 2;
  amenu[1].prev_menu := 0;

  amenu[2].name := 'Sound';
  if musik then amenu[2].item[1].name := 'Music: ON' else
    amenu[2].item[1].name := 'Music: OFF';
  amenu[2].item[1].next_menu := 251; //Prozedur wird aufgerufen wenn grer als 127
  if effekte then amenu[2].item[2].name := 'SoundFX: ON' else
    amenu[2].item[2].name := 'SoundFX: OFF';
  amenu[2].item[2].next_menu := 250; //Prozedur wird aufgerufen
  amenu[2].number_of_items := 2;
  amenu[2].prev_menu := 0;

  amenu[3].name := 'User Map';
  amenu[3].item[1].name := 'Map:';
  amenu[3].item[1].next_menu := 247; //Prozedur wird aufgerufen wenn grer als 127
  amenu[3].number_of_items := 1;
  amenu[3].prev_menu := 0;

  atext[0].line[1] :=
    '2000 a.d.. The scenery is the antique Wipperfuerth,';
  atext[0].line[2] :=
    'a town, which name is a synonym for the organized crime.';
  atext[0].line[3] :=
    'In this town, theres a closed asylum. Here it all begins....';
  atext[0].line[4] :=
    'You are Jack. Jack Napier. Waking up in the middle of the';
  atext[0].line[5] :=
    'night in your small room, seeing the moon, makes you know your quest!';
  atext[0].line[6] :=
    'Nothing will hold you from fulfilling this quest! Not your strait-jacket nor';
  atext[0].line[7] :=
    'your daily ration of pills.';
  atext[0].line[8] :=
    'You fall asleep. Consequent. And dream...:';
  atext[0].line[9] :=
    '2500 a.d.. You awake in a rendered 3D-World, surrounded';
  atext[0].line[10] :=
    'by perfect textures, 30 million texels per second, constant 60 frames';
  atext[0].line[11] :=
    'and a 3D Sound, that makes your blood freeze in your artery!';
  atext[0].line[12] :=
    'You look down at yourself. You are a Mark 5 Fighting Robot,';
  atext[0].line[13] :=
    'armed to destroy the dark lord Hendrik, slave-driver of thousands of';
  atext[0].line[14] :=
    'computer experts, in a gigantic showdown!.';
  atext[0].line[15] :=
    'You are armed with the wohle arsenal of the UFPMES (United Federation of';
  atext[0].line[16] :=
    'Planets and Moons, except Sirius).';
  atext[0].line[17] :=
    'Nothing can stop ya! Your nearly perfect programmed artificial intelligence';
  atext[0].line[18] :=
    'knows its mission. Nothing can get in your way. Except the tiny';
  atext[0].line[19] :=
    'programming error in the AI procedure, Trademark Bordelbardel.';
  atext[0].line[20] :=
    'You already begin to feel the effect of this programming error, you feel';
  atext[0].line[21] :=
    'unable to resist gravity. You fall to the ground!';
  atext[0].line[22] :=
    'Not that this gravity would be too strong, no, it is, as usual in futurisic LA,';
  atext[0].line[23] :=
    'at 9.81 N/kg, inertia doesnt listen anymore to Newtons laws...';
  atext[0].line[24] :=
    '..not since this accident in 2324, caused by the grandgrandfather of lord Hendrik,';
  atext[0].line[25] :=
    'C.C.Blechschaedel. "Enough of history!!"';
  atext[0].line[26] :=
    'you think by yourself! Lying on the floor, you begin to scan the';
  atext[0].line[27] :=
    'skyscrapers, which are threatening to crash above you!.';
  atext[0].line[28] :=
    'Monuments of the modern civilisation, built years ago by the brilliant architect';
  atext[0].line[29] :=
    'Van Brdgen, with spritual support by his "Prediger".';
  atext[0].line[30] :=
    'Suddenly, your main energy fades! Youre trying to activate your emergency energy.';
  atext[0].line[31] :=
    'Not much more energy than in a solar-clock feeds your cerebral cortex!';
  atext[0].line[32] :=
    '';
  atext[0].line[33] :=
    'You feel weak! You know, there isnt much hope left! "Damn';
  atext[0].line[34] :=
    'programming error!" you think. Suddenly, you have an idea!!';
  atext[0].line[35] :=
    '"Under help of desintegrated kalciniating correlations-stimuli is it possible';
  atext[0].line[36] :=
    'to make the semilinear polyandry of the refractured interdependanceparakme';
  atext[0].line[37] :=
    'under observation of the amorph isoquants at simultan synchron';
  atext[0].line[38] :=
    'dephlegmation that way relative, that a imputability of the eprigonetic';
  atext[0].line[39] :=
    'consens is mostly rationaliated."';
  atext[0].line[40] :=
    'Or shorter: You make your CPU build a metaphoric Picture, rather than,';
  atext[0].line[41] :=
    'check uncompiled sourcecode. Because of the lack of energy, you are a bit';
  atext[0].line[42] :=
    'disappointed...twodimensional jumpinggame...but coloured. In the back you';
  atext[0].line[43] :=
    'recognize some flashes of your RAM. Time has come!! You may not lose';
  atext[0].line[44] :=
    'any time!';
  atext[0].line[45] :=
    'Lead your last few electrical impulses through the transcendental sureality';
  atext[0].line[46] :=
    'of a dying artifical intelligence, rugged by a programming error!';
  atext[0].line[47] :=
    'But watch out! Only if you make it, the Mark 5 can kick the evil';
  atext[0].line[48] :=
    'lord Hendrik into a cryogen chamber. And only if he makes it,';
  atext[0].line[49] :=
    'Jack Napier has got no nightmare!';
  atext[0].line[50] :=
    'Only then, the world will be good again!';
  atext[0].line[51] :=
    'And only THEN I am playing with the thought of learning english!';
  atext[0].line[52] :=
    '';



  atext[1].line[1] := 'The Back2D Team:';
  atext[1].line[2] := '';
  atext[1].line[3] := '"Lord" Hendrik Friedel';
  atext[1].line[4] := 'hendrik@galaxycorp.com';
  atext[1].line[5] := '';
  atext[1].line[6] := 'Projektleitung';
  atext[1].line[7] := '-Einbinden der Prozeduren';
  atext[1].line[8] := '-Verbesserungen';
  atext[1].line[9] := '-Nahezu smtliche Kleinarbeiten';
  atext[1].line[10] := 'Hufigster Spruch:';
  atext[1].line[11] := 'Bis Dienstag ist alles da! SPTESTENS!!!';
  atext[1].line[12] := '';
  atext[1].line[13] := '';
  atext[1].line[14] := 'Jens Bardel';
  atext[1].line[15] := 'jensabi2000@yahoo.de';
  atext[1].line[16] := '';
  atext[1].line[17] := '-Knstliche Intelligenz der Gegner';
  atext[1].line[18] := 'Beschwerden ber unbesiegbare Gegner an Jens...';
  atext[1].line[19] := 'und der verlorene Jesus';
  atext[1].line[20] := '';
  atext[1].line[21] := '';
  atext[1].line[22] := 'Gero (van) Brdgen';
  atext[1].line[23] := 'supersucker@nikocity.de';
  atext[1].line[24] := '';
  atext[1].line[25] := '-Leveleditor und Sound';
  atext[1].line[26] := '';
  atext[1].line[27] := '';
  atext[1].line[28] := 'Christian Prediger';
  atext[1].line[29] := 'prediger@berg.net';
  atext[1].line[30] := '';
  atext[1].line[31] := '-Leveleditor und Sound';
  atext[1].line[32] := 'Die beiden hatten viel Spa dabei...';
  atext[1].line[33] := '("Schon wieder abgestrzt!")';
  atext[1].line[34] := '';
  atext[1].line[35] := '';
  atext[1].line[36] := 'Marco (Napier) Nassenstein:';
  atext[1].line[37] := 'marco@nassenstein.com';
  atext[1].line[38] := '';
  atext[1].line[39] := 'Musik, Promotion, Speedcontrol (TM), Beta-Tester,';
  atext[1].line[40] := 'Packungsdesign, Konzept... (Bla bla, schwafel...)';
  atext[1].line[41] := '...und die beknackteste Story aller Zeiten...';
  atext[1].line[42] := 'Translation?';
  atext[1].line[43] := '';
  atext[1].line[44] := 'Christoph "Blechschdel" Blechmann';
  atext[1].line[45] := 'mail@ch-blechmann.de';
  atext[1].line[46] := '';
  atext[1].line[47] := '-Bewegung der Player';
  atext[1].line[48] := '-Gravitation';
  atext[1].line[49] := '-Credits';
  atext[1].line[50] := '';
  atext[1].line[51] := '';
  atext[1].line[52] := '';
  atext[1].line[53] := 'Special Thanks to:';
  atext[1].line[54] := '';
  atext[1].line[55] := 'Jens Wengendorf'; //oder wie auch immer...
  atext[1].line[56] := '';
  atext[1].line[57] := '-Sounds';
  atext[1].line[58] := '';
  atext[1].line[59] := '';
  atext[1].line[60] := 'Hans "Meister" Klzer';
  atext[1].line[61] := '';
  atext[1].line[62] := 'Ohne ihn, unseren Lehrmeister in den letzten Jahren,';
  atext[1].line[63] := 'wre das gesamte Projekt undenkbar...';
  atext[1].line[64] := '';
  atext[1].line[65] := '';
  atext[1].line[66] := '---- T H E   E N D ----';
  draw.cursor := crnone;
  player_selected := 0;
  dont_move := false;
  impuls := 1;
  number_of_players := 1;
  erstemal_dieses_game := false;
  erstemal_dieses_level := false;
  try
    draw.Initialize;
  except
    MessageDlg('Direct Draw could not be initialized!', mtError, [mbOK], 0);
    close;
  end;
 {Color Table}
  ImageList.Items.MakeColorTable;
  Draw.ColorTable := ImageList.Items.ColorTable;
  Draw.DefColorTable := ImageList.Items.ColorTable;
  Draw.UpdatePalette;
 {Ende Color Table}
  startscene(gstitle);
 {ende Initialisierungen}
end;


procedure TForm1.DXTimer1Timer(Sender: TObject; LagCount: Integer);
begin
  dxinput.update;
  if not Draw.CanDraw then exit;
  case FScene of
    gsTitle: SceneTitle;
    gsmain: Scenemain;
    gsGameOver: SceneGameOver;
    gsMenu: SceneMenu;
  end;
  if FNextScene <> gsNone then
  begin
    StartScene(FNextScene);
    FNextScene := gsNone;
  end;
  if (midilooped) and (mediaplayer1.mode = mpstopped) and (amenu[2].item[1].name <> 'Music: OFF') then
  begin
    mediaplayer1.open;
    mediaplayer1.play;
  end;
{SpeedControl(TM) ..... MARCO IST doof!}
{Angleichen der Geschwindigkeit der Spiels mit Multiplikator "impuls"}
//  currentfps := DXtimer1.FrameRate; //Momentane Framerate = "currentfps"
//  if gettickcount < firsttickcount + 1000 then //die erste sekunde wird der letzt bekannte wert aus der ini genommen
//    currentfps := lastfps;
//  if currentfps < 1 then currentfps := 1; //Weniger als 1 Frame? Dann lieber einer!
//  impuls := 15 / currentfps; //Multiplikator fr XSchritt etc. ist "impuls" (REAL!)
  xschritt := 15 {round(xspeed * impuls)};
  if dovollbild then
  begin
    vollbild;
    dovollbild := false;
  end;

  //grav:=round(gravbasis*impuls);
  {SpeedControl(TM) Ende}
  Draw.Flip; //in den VOrdergrund bringen
end;

procedure TForm1.DrawInitializing(Sender: TObject);
begin
  if doFullScreen in Draw.Options then
  begin
    BorderStyle := bsNone;
    borderIcons := [];
    Draw.Cursor := crNone;
  end else
  begin
    BorderStyle := bsSingle;
    borderIcons := [biSystemMenu, biMinimize, biMaximize];
    Draw.Cursor := crDefault;
  end;

end;

procedure tform1.newgame;
begin
  PlaySound('Steam1', False);
  eigenemaps := false;
  erstemal_dieses_game := true;
  startzeit := gettickcount;
  startscene(gsmain);
end;

procedure TForm1.vollbild;
var vol: boolean;
begin
  begin
  {  Screen mode change  }
    if amenu[0].item[7].name = 'Fullscreen: OFF (F4)' then
    begin
      amenu[0].item[7].name := 'Fullscreen: ON (F4)';
      vol := true;
    end
    else
    begin
      amenu[0].item[7].name := 'Fullscreen: OFF (F4)';
      vol := false;
    end;
    if vol then
    begin
    {  FullScreen mode  }
      Draw.Finalize;
      if not (doFullScreen in draw.Options) then
        StoreWindow;
      draw.Options := draw.Options + [doFullScreen];
      draw.Display.Width := 800;
      draw.Display.Height := 600;
      draw.Display.BitCount := 16;
      draw.Initialize;
    end else
    begin
    {  Window mode  }
      draw.Finalize;
      if doFullScreen in draw.Options then
        RestoreWindow;
      draw.Options := draw.Options - [doFullScreen];
      draw.Display.Width := 800;
      draw.Display.Height := 600;
      draw.Display.BitCount := 16;
      draw.Initialize;
    end;
  end;
end;

procedure TForm1.DrawInitialize(Sender: TObject);
begin
  Draw.Cursor := crnone;
end;

procedure tform1.enter_pressed;
type
  tsavegame = record
    level: integer;
    punkte1: integer;
    leben1: integer;
    leben2: integer;
    health1: integer;
    punkte2: integer;
    health2: integer;
    spielzeit1: integer;
    spielzeit2: integer;
    multiplayer: boolean;
  end;
var savefile: file of tsavegame;
  savegame: tsavegame;
  searchrec: tsearchrec;
  i: integer;
begin
  if amenu[currentmenu].item[currentselecteditem].next_menu < 128 then //wenn es ein Nachfolgemen gibt
  begin
    currentmenu := amenu[currentmenu].item[currentselecteditem].next_menu;
    currentselecteditem := 1;
    if currentmenu = 3 then //dateien einlesen
    begin
      ausermaps.free;
      ausermaps := TStringList.Create;
      if findfirst(extractfilepath(paramstr(0)) + '\*.map', faAnyFile, SearchRec) = 0 then
      begin
        while findnext(searchrec) = 0 do
        begin
          AUsermaps.add(searchrec.name);
        end;
      end;
      findclose(searchrec);
      ausermaps.sort;
      ausermaps.find(usermap, currentusermapindex);
      if currentusermapindex <> 255 then usermap := ausermaps.strings[currentusermapindex]
      else usermap := '';
    end;
  end
  else //wenn eine Prozedur ausgefhrt wird
    case amenu[currentmenu].item[currentselecteditem].next_menu of
      255: begin
          if amenu[0].item[6].name = 'Multiplayer: OFF' then
          begin
            amenu[0].item[6].name := 'Multiplayer: ON';
            number_of_players := 2;
          end
          else
          begin
            amenu[0].item[6].name := 'Multiplayer: OFF';
            number_of_players := 1;
          end;
          newgame;
        end;
      254:
        begin
          if fsceneprevious = gsmain then
            if MessageDlg('Save gamestate?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
            begin
              savegame.level := level;
              savegame.punkte1 := player[1].punkte;
              savegame.health1 := player[1].health;
              savegame.leben1 := player[1].leben;
              savegame.spielzeit1 := player[1].spielzeit;
              if number_of_players = 2 then
              begin
                savegame.multiplayer := true;
                savegame.leben2 := player[2].leben;
                savegame.health2 := player[2].health;
                savegame.punkte2 := player[2].punkte;
                savegame.spielzeit2 := player[2].spielzeit;
              end
              else
                savegame.multiplayer := false;
              savedialog1.execute;
              if fileexists(savedialog1.filename) then
              try
                assignfile(savefile, savedialog1.filename);
                Rewrite(savefile);
                write(savefile, savegame);
                closefile(savefile);
              except
                MessageDlg('An error occured during saving!', mtError, [mbOK], 0);
              end;

            end;
          application.terminate;
        end;
      253:
        begin
          dont_move := not dont_move;
          if player_selected = 0 then player_selected := 1
          else player_selected := 0;
        end;
      252:
        begin
          dont_move := not dont_move;
          if player_selected = 0 then player_selected := 2
          else player_selected := 0;
        end;
      251:
        begin
          if amenu[2].item[1].name = 'Music: ON' then
          begin
            mediaplayer1.Stop;
            amenu[2].item[1].name := 'Music: OFF'
          end
          else
          begin
            mediaplayer1.filename := currentmidifile;
            if mediaplayer1.filename <> '' then
            begin
              mediaplayer1.Open;
              mediaplayer1.play;
            end;
            amenu[2].item[1].name := 'Musik: ON'
          end
        end;
      250:
        begin
          if amenu[2].item[2].name = 'SoundFX: ON' then
          begin
            dxsound.finalize;
            amenu[2].item[2].name := 'SoundFX: OFF'
          end
          else
          begin
            dxsound.initialize;
            amenu[2].item[2].name := 'SoundFX: ON'
          end
        end;
      249: vollbild;
      248: newgame;
      247:
        dont_move := not dont_move;
      246:
        begin
          if MessageDlg('There is no 3D acceleration!!', mtError, [mbOK, mbRetry], 0) = mrretry then
            if MessageDlg('If you want 3D acceleration, you should ' + #13 + #10 + 'donate some money!!', mtConfirmation, [mbYes, mbNo], 0) = mryes then
              MessageDlg('Cool! Our bank informations can be found at' + #39 + 's Back2D.2XS.net', mtInformation, [mbOK], 0) else
              if MessageDlg('Dont you want to rethink it???', mtWarning, [mbYes, mbNo], 0) = mryes then
                showmessage('THANX!') else showmessage('Just think of all the fun you have playing this game!!')
        end;
      245:
        begin
          textart := 1;
          startscene(gstitle)
        end;
      244:
        begin
          eigenemaps := true;
          PlaySound('Steam1', False);
          erstemal_dieses_game := true;
          startzeit := gettickcount;
          startscene(gsmain);
        end;
      243:
        begin
          opendialog1.execute;
          if fileexists(opendialog1.FileName) then
          begin
            try
              assignfile(savefile, opendialog1.FileName);
              Reset(savefile);
              read(savefile, savegame)
            except
            end;
            playmidi('credits', true); //'end'
            number_of_players := 1;
            player[1].leben := savegame.leben1;
            player[1].punkte := savegame.punkte1;
            player[1].health := savegame.health1;
            player[1].spielzeit := savegame.spielzeit1;
            level := savegame.level;
            if savegame.multiplayer then
            begin
              number_of_players := 2;
              player[2].leben := savegame.leben2;
              player[2].punkte := savegame.punkte2;
              player[2].health := savegame.health2;
              player[2].spielzeit := savegame.spielzeit2;
              level := savegame.level;
            end;
            erstemal_dieses_level := true;
            startzeit := gettickcount;
            startscene(gsmain);
          end;
        end;
        242:
        begin
          if amenu[0].item[9].name = 'Backgrounds: OFF' then
          amenu[0].item[9].name := 'Backgrounds: ON' else
          amenu[0].item[9].name := 'Backgrounds: OFF'
        end;
    end;
end;

procedure tform1.escape_pressed;
begin
  if amenu[currentmenu].prev_menu = 255 then //ist schon das unterste Men -> raus aus dem men
    FScene := FScenePrevious
  else
    if currentmenu = 3 then
    begin
      currentmenu := 0;
      newgame;
    end
    else
      currentmenu := amenu[currentmenu].prev_menu;
//end;
  dont_move := false;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if (fscene = gsmenu) then
  begin
    if (key = #13) or (key = #32) then
      enter_pressed;
    if (player_selected > 0) and (ord(key) >= 32) and (currentmenu = 1) then
      player[player_selected].name := player[player_selected].name + key;
    if dont_move and (ord(key) >= 32) and (currentmenu = 3) then
    begin // wenn buchstabe dann zu dem Bustaben in der Liste!!!
      if key <> #32 then
      begin
        if key = lastkey then
          inc(number_of_thiskey) else
          number_of_thiskey := 0;
        lastkey := key;
        ausermaps.find(key, currentusermapindex);
        inc(currentusermapindex, number_of_thiskey);
        if currentusermapindex > ausermaps.count - 1 then currentusermapindex := ausermaps.count - 1;
        if ausermaps.strings[currentusermapindex][1] <> key then
        begin
          dec(currentusermapindex, number_of_thiskey);
          number_of_thiskey := 0;
        end;
        if currentusermapindex <> 255 then usermap := ausermaps.strings[currentusermapindex]
        else usermap := '';
      end;
    end;
    if (key = #8) and (currentmenu = 1) then
      delete(player[player_selected].name, length(player[player_selected].name), 1);
    if (key = #8) and (currentmenu = 3) and dont_move then
      delete(usermap, length(usermap), 1);
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  try
    DXSound.Initialize;
  except
    DXSound.Finalize;
    amenu[2].item[1].name := 'Music: OFF';
    amenu[2].item[2].name := 'SoundFX: OFF';
  end;

end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (ssalt in shift) and (ssctrl in shift) then
  begin
    case key of
      111: begin inc(player[1].leben, 5); inc(player[2].leben, 5) end;
      106:
        begin
          inc(level);
          erstemal_dieses_level := true;
          FNextScene := gsmain;
          draw.flip;
        end;
    end;
  end;
  if key = vk_f1 then
  begin
    if (FScene <> gsMenu) then
    begin
      FNextScene := gsMenu;
      dont_move := false;
      FScenePrevious := FScene;
    end
    else
      if currentmenu = 3 then newgame else
      begin
        FNextScene := FScenePrevious;
        FScenePrevious := FScene;
      end;
    playsound('menu', false);
  end;
  if key = vk_f2 then
    newgame;
  if not (ssalt in shift) and (key = vk_f4) then
    vollbild;
  if (Fscene = gsmenu) then
    case key of
      vk_down:
        if not (dont_move) and (Fscene = gsmenu) and (currentselecteditem < amenu[currentmenu].number_of_items) then
        begin inc(currentselecteditem); playsound('menu', false); end else
          if not (dont_move) and (Fscene = gsmenu) and (currentselecteditem >= amenu[currentmenu].number_of_items) then
          begin currentselecteditem := 1; playsound('menu', false); end;
      vk_up: if not (dont_move) and (Fscene = gsmenu) and (currentselecteditem > 1) then
        begin playsound('menu', false); dec(currentselecteditem); end else
          if not (dont_move) and (Fscene = gsmenu) and (currentselecteditem <= 1) then
          begin currentselecteditem := amenu[currentmenu].number_of_items; playsound('menu', false); end;
      vk_escape: escape_pressed;
//space ist in onkeypress
    end;
  if dont_move and (currentmenu = 3) then
  begin
    if key = 38 then // 38:oben 40: unten
      if currentusermapindex = 255 {keine} then currentusermapindex := 0 //erste
      else
        if currentusermapindex < ausermaps.count - 1 then
          inc(currentusermapindex) else
          currentusermapindex := 255;
    if key = 40 then // 38:oben 40: unten
      if currentusermapindex = 255 then currentusermapindex := ausermaps.count - 1 //letzte
      else
        if (currentusermapindex > 0) then
          dec(currentusermapindex) else
          currentusermapindex := 255;
    if currentusermapindex <> 255 then usermap := ausermaps.strings[currentusermapindex]
    else usermap := '';
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  try
    configu.writeinteger('Main', 'LastFPS', lastfps);
    configu.WriteString('Main', 'Player1Name', player[1].name);
    configu.WriteString('Main', 'Player2Name', player[2].name);
    configu.WriteString('Main', 'Usermap', usermap);
    configu.Writebool('Main', 'Vollbild', amenu[0].item[7].name = 'Fullscreen: ON (F4)');
    configu.Writebool('Main', 'Musik', amenu[2].item[1].name = 'Music: ON');
    configu.Writebool('Main', 'Effekte', amenu[2].item[2].name = 'SoundFX: ON');
  except
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  configu.free;
end;

end.

